<%@include file="header.inc"%>
<%@page import="util.web.form.*"%>
<%
	FormConfiguration conf = new FormConfiguration();
	conf.setSubmissionMethod(SubmissionMethod.POST);
	// Only POST submission is accepted
	
	conf.setExtraAllowed(false);
	// Reject non-registered parameters
	
	FormProperties props = new FormProperties(conf);
	
	ParamsConstraints pc = new ParamsConstraints();
	
	
	// Register mandatory and non-constrained parameters
	// ** Required as extra parameters are not allowed **
	pc.setConstraints("lastname", new DataParamConstraints(true));
	pc.setConstraints("publish", new DataParamConstraints(true));
	
	DataParamConstraints dpc;
	
	// Define constraints on "firstname" parameter
	dpc = new DataParamConstraints();
	dpc.setMaxOccur(1);	// Single value expected
	dpc.setExpectedValues("foo", "bar");
	
	pc.setConstraints("firstname", dpc);
	
	// Define constraints on "gender" parameter
	dpc = new DataParamConstraints();
	dpc.setMinOccur(1);	// Similar to 'setRequired(true)'
	dpc.setMaxOccur(1);	// Single value expected
	dpc.setExpectedValues("male", "female");
	
	pc.setConstraints("gender", dpc);
	
	// Define constraints on "comment" parameter
	dpc = new DataParamConstraints(true);
	dpc.setMaxSize(10);	// 10 characters maximum allowed
	dpc.setMaxOccur(1);	// Single value expected
	
	pc.setConstraints("comment", dpc);
	
	// Update global form properties with these constraints
	props.setParamsConstraints(pc);

	FormParams fp = new FormParams(request, props);
	
	FormElement fe;
	
	String[] values = pc.getRegisteredParams();
%>
		<h1>Retrieving elements from request</h1>
<%
	FormDataElement fde;
	int j;
	for (String current : values) {
		fe = fp.getParam(current);
		if (fe == null) {
%>
		<p class="warning">Request does not contain <%= current %></p>
<%
		}
		else {
%>
		<p>Retrieving <%= current %> from request:</p>
		<ul>
			<li>Number of values: <%= fe.getNumberOfValues() %></li>
<%
			if (fe.isFile()) {
				// Should not happen in this particular example
%>
			<li><span class="error">Parameter is a file</span></li>
<%
			}
			else {
				j = 1;
				fde = (FormDataElement)fe;
				for (String val : fde) {
%>
			<li>Value <%= j %>: <%= val %></li>
<%
					j++;
				}
%>
		</ul>
<%
			}
		}
	}
	
	fp.destroy();
%>
<%@include file="footer.inc"%>