<%@include file="header.inc"%>
<%@page import="util.web.form.*"%>
<%!
	private static final String destFolder = "Uploaded";
	// Replace with your own relative or absolute path
	// '.' refers to Tomcat root installation directory
%>
<%
	// In case properties are not mentionned, Tomcat root
	// directory is used to store temporary uploaded files
	
	FormConfiguration conf = new FormConfiguration(SubmissionMethod.MULTIPART, false);
	// Refuse non POST MULTIPART requests
	// Only registered parameters can be received
	
	FileParamConstraints fpc = new FileParamConstraints(true);
	fpc.setMaxSize(50000);	// 50 Ko maximum for file upload
	// fpc.setMinOccur(1); // Not necessary as fpc was created as a mandatory parameter
	fpc.setMaxOccur(2);	// Maximum of 2 files can be uploaded
	
	// Only a few file extensions are accepted
	fpc.setExpression(".+\\.(?i)(png|jp(e?)g|gif|bmp)");
	
	// Also use content types verification (to make sure)
	fpc.setExpectedContentTypes("image/png", "image/jpeg", "image/gif", "image/bmp");
	
	ParamsConstraints pc = new ParamsConstraints();
	pc.setConstraints("myFile", fpc);
	pc.setConstraints("overwrite");
	
	// Update global form properties with these constraints
	FormProperties props = new FormProperties();
	props.setMainFormConfiguration(conf);
	props.setParamsConstraints(pc);
	
	// Receive the request according to the expected properties
	FormParams fp = new FormParams(request, props);
	
	// Checkbox is received only if checked
	boolean overwrite = fp.hasParam("overwrite");
	
	FormElement fe = fp.getParam("myFile");
%>
<%
	if (fe == null) {
%>
		<h1 class="error">Request does not contain expected element(s)</h1>
<%
	}
	else {
%>
		<h1>Retrieving elements from request</h1>
		<p>Number of values: <%= fe.getNumberOfValues() %></p>
<%
		if (!fe.isFile()) {
%>
		<p class="error">Parameter is not a file</p>
<%
		}
		else {
%>
		<ul>
<%
			// Retrieve all uploaded files
			FormFileElement ffe = (FormFileElement)fe;
			for (FileElement elem : ffe) {
%>
			<li>Storing file "<%= elem.getFileName() %>" to "<%= destFolder %>"...
<%
				if (elem.copyTo(destFolder, true, overwrite)) {
%>
				<span class="success">Done.</span></li>
<%
				}
				else {
%>
				<span class="error">Already exists!</span></li>
<%
				}
			}
%>
		</ul>
<%
		}
	}

	fp.destroy();	// Removes temporary files
	// Only files uploaded by the current thread are deleted, thanks to the
	// "thread-safe" implementation of FormParams
%>
<%@include file="footer.inc"%>