<%@include file="header.inc"%>
<%@page import="util.web.form.*, util.web.form.extra.*, util.web.form.error.*, java.util.*"%>
<%!
final class PasswordValidationConstraint implements FormValidationConstraint {
	public void validate(FormParams fp)
	throws FormValidationConstraintException {
		FormDataElement fde = (FormDataElement)fp.getParam("passwd");
		if (!fde.getValue(0).equals(fde.getValue(1))) {
			throw new FormValidationConstraintException(fp, "Passwords must be identical", "passwd");
		}
	}
}
%>
<%	
	FormConfiguration conf = new FormConfiguration(false);
	// Any submission method is accepted (get, post, post/multipart) by default
	// No extra parameter is allowed
	
	FormProperties props = new FormProperties(conf);
	
	ParamsConstraints pc = new ParamsConstraints();
	
	DataParamConstraints dpc;
	
	
	// Define constraints on "email" parameter
	dpc = new DataParamConstraints();
	
	ValidationConstraints paramValidationConstraints = new ValidationConstraints();
	paramValidationConstraints.setValidationIds("emailId");
	dpc.setValidationConstraints(paramValidationConstraints);
	
	pc.setConstraints("email", dpc);
	
	
	// Define constraints on "password" parameters
	dpc = new DataParamConstraints();
	dpc.setMinOccur(2);	// Both 'passwd' fields must not be empty
	dpc.setMaxOccur(2);	// No more than 2 fields named 'passwd' are accepted
	pc.setConstraints("passwd", dpc);
	
	/*** NOTE ***
	// Password constraints can also be expressed as follows.
	// However, a single value (and the other passowrd field left blank) is tolerated,
	// contrary to the previous constraints definitions
	dpc = new DataParamConstraints(true);
	dpc.setMaxOccur(2);	// No more than 2 fields named 'passwd' are accepted
	pc.setConstraints("passwd", dpc);
	*************/
	
	
	// Update global form properties with these constraints
	props.setParamsConstraints(pc);
	
	ValidationConstraints formValidationConstraints = new ValidationConstraints();
	formValidationConstraints.setValidationIds("pwdId");
	props.setValidationConstraints(formValidationConstraints);
	
	// Indicate email validation asssociated code
	Hashtable<String, ParamValidationConstraint> paramsValidations = new Hashtable<String, ParamValidationConstraint>(1);
	paramsValidations.put("emailId", new EmailValidationConstraint());
	
	// Initialize form password values check associated code
	Hashtable<String, FormValidationConstraint> formValidations = new Hashtable<String, FormValidationConstraint>(1);
	formValidations.put("pwdId", new PasswordValidationConstraint());
	
	// Parse incoming request using given extra validations
	FormParams fp = new FormParams(request, props, paramsValidations, formValidations);
	
	FormElement fe;
	
	String[] values = pc.getRegisteredParams();
%>
		<h1>Retrieving elements from request</h1>
<%
	FormDataElement fde;
	int j;
	for (String current : values) {
		fe = fp.getParam(current);
		if (fe == null) {
%>
		<p class="warning">Request does not contain <%= current %></p>
<%
		}
		else {
%>
		<p>Retrieving <%= current %> from request:</p>
		<ul>
			<li>Number of values: <%= fe.getNumberOfValues() %></li>
<%
			if (fe.isFile()) {
				// Should not happen in this particular example
%>
			<li><span class="error">Parameter is a file</span></li>
<%
			}
			else {
				j = 1;
				fde = (FormDataElement)fe;
				for (String val : fde) {
%>
			<li>Value <%= j %>: <%= val %></li>
<%
					j++;
				}
%>
		</ul>
<%
			}
		}
	}
	
	fp.destroy();
%>
<%@include file="footer.inc"%>