<%@include file="header.inc"%>
		<p class="warning">Files will be stored by default to "<span class="teletype">./Uploaded</span>" directory, where "<span class="teletype">./</span>" refers to your applications server installation directory. This directory is automatically created. This can be changed by modifying "<span class="teletype">formXXSubmitted.jsp</span>" pages.</p>
		
		<h1>Non-constrained form submission tests</h1>
		
		<h2>Common GET (or POST) submission</h2>
		<form action="form11Submitted.jsp" method="get">
			<table>
				<tr>
					<td>Firstname:</td><td><input type="text" name="firstname" /></td>
				</tr>
				<tr>
					<td>Lastname:</td><td><input type="text" name="lastname" /></td>
				</tr>
				<tr>
					<td colspan="2"><input type="radio" name="gender" value="male" /> Male</td>
				</tr>
				<tr>
					<td colspan="2"><input type="radio" name="gender" value="female" /> Female</td>
				</tr>
				<tr>
					<td>Comment:</td><td><textarea name="comment"></textarea></td>
				</tr>
				<tr>
					<td colspan="2"><input type="checkbox" name="publish" value="yes" /> Publish on the Internet</td>
				</tr>
				<tr>
					<td colspan="2"><button type="submit" class="submit"><img src="send.gif" title="Send form11" alt="[Send form11]" /> Send</button> (form11Submitted.jsp)</td>
				</tr>
			</table>
		</form>
		
		<p class="warning">Empty textual fields are received as empty fields when submission method is <span class="teletype">GET</span> or <span class="teletype">POST</span>.
		However, <span class="teletype">POST/MULTIPART</span> method leads not to receive empty fields.</p>
		<p>Please check other submission methods by replacing <span class="teletype">method="get"</span> with one of the following:</p>
		<ul>
			<li><span class="teletype">method="post"</span></li>
			<li><span class="teletype">method="post" enctype="multipart/form-data"</span></li>
		</ul>
		
		<h2>File upload (MULTIPART)</h2>
		<form action="form12Submitted.jsp" method="post" enctype="multipart/form-data">
			<table>
				<tr>
					<td><input type="file" name="myFile" /></td>
				</tr>
				<tr>
					<td><input type="file" name="myFile" /></td>
				</tr>
				<tr>
					<td><input type="checkbox" name="overwrite" value="yes" /> Overwrite existing files</td>
				</tr>
				<tr>
					<td><button type="submit" class="submit" ><img src="send.gif" title="Send form12" alt="[Send form12]" /> Send</button> (form12Submitted.jsp)</td>
				</tr>
			</table>
		</form>
		<p class="caution">File input fields names are identical.</p>
		<p>Form submission method must be declared <span class="teletype">post</span> and encoding type set to <span class="teletype">multipart/form-data</span> to allow files uploads.</p>
		
		
		<%-- ******************************************************************** --%>
		
		<h1>Constrained form submission tests</h1>
		
		<h2>Common GET (or POST) submission</h2>
		<p class="warning">Submission method is restricted to <span class="teletype">POST</span>.</p>
		<p class="warning">All fields but <span class="teletype">firstname</span> are mandatory. They must not be left empty or not selected (in case of checkboxes or radio butttons).</p>
		<form action="form21Submitted.jsp" method="post">
			<table>
				<tr>
					<td>Firstname:</td><td><input type="text" name="firstname" /> <span class="warning">(only accepts an empty value, <span class="teletype">foo</span> or <span class="teletype">bar</span> values)</span></td>
				</tr>
				<tr>
					<td>Lastname:</td><td><input type="text" name="lastname" /></td>
				</tr>
				<tr>
					<td colspan="2"><input type="radio" name="gender" value="male" /> Male</td>
				</tr>
				<tr>
					<td colspan="2"><input type="radio" name="gender" value="female" /> Female</td>
				</tr>
				<tr>
					<td>Comment:</td><td><textarea name="comment"></textarea> <span class="warning">(length limited to <span class="teletype">10</span> characters)</span></td>
				</tr>
				<tr>
					<td colspan="2"><input type="checkbox" name="publish" value="yes" /> Publish on the Internet</td>
				</tr>
				<tr>
					<td colspan="2"><button type="submit" class="submit" ><img src="send.gif" title="Send form21" alt="[Send form21]" /> Send</button> (form21Submitted.jsp)</td>
				</tr>
			</table>
		</form>
		<p>Please check other submission methods by replacing <span class="teletype">method="get"</span> with one of the following:</p>
		<ul>
			<li><span class="teletype">method="post"</span></li>
			<li><span class="teletype">method="post" enctype="multipart/form-data"</span></li>
		</ul>
		
		<h2>File upload (MULTIPART)</h2>
		<p class="warning">This form only accepts <span class="teletype">.png</span>, <span class="teletype">.jpg</span>, <span class="teletype">.jpeg</span>, <span class="teletype">.gif</span> and <span class="teletype">.bmp</span> files up to <span class="teletype">50Ko</span>.</p>
		<p class="warning">At least one file must be submitted.</p>
		<form action="form22Submitted.jsp" method="post" enctype="multipart/form-data">
			<table>
				<tr>
					<td><input type="file" name="myFile" /></td>
				</tr>
				<tr>
					<td><input type="file" name="myFile" /></td>
				</tr>
				<tr>
					<td><input type="checkbox" name="overwrite" value="yes" /> Overwrite existing files</td>
				</tr>
				<tr>
					<td><button type="submit" class="submit"><img src="send.gif" title="Send form22" alt="[Send form22]" /> Send</button> (form22Submitted.jsp)</td>
				</tr>
			</table>
		</form>
		<p class="caution">File input fields names are identical.</p>
		<p>Uploads are cancelled (temporary files are removed) in case at least one file does not conform to the expected constraints.</p>
		
		<h2>Using user-defined parameter and form validation constraints</h2>
		<p class="warning">Submission method is restricted to <span class="teletype">POST</span>.</p>
		<form action="form23Submitted.jsp" method="post">
			<table>
				<tr>
					<td>Email:</td><td><input type="text" name="email" /> <span class="warning">(only accepts empty or <span class="teletype">email</span> values)</span></td>
				</tr>
				<tr>
					<td>Password:</td><td><input type="password" name="passwd" /><br/><input type="password" name="passwd" /> <span class="warning">(password fields are mandatory and must be identical)</span></td>
				</tr>
				<tr>
					<td colspan="2"><button type="submit" class="submit" ><img src="send.gif" title="Send form23" alt="[Send form23]" /> Send</button> (form23Submitted.jsp)</td>
				</tr>
			</table>
		</form>
		<p class="caution">Password fields names are identical.</p>
<%@include file="footer.inc"%>